/**
 * Copyright (C) 2005-2011 by Rivello Multimedia Consulting (RMC).                    
 * code [at] RivelloMultimediaConsulting [dot] com                                                  
 *                                                                      
 * Permission is hereby granted, free of charge, to any person obtaining
 * a copy of this software and associated documentation files (the      
 * "Software"), to deal in the Software without restriction, including  
 * without limitation the rights to use, copy, modify, merge, publish,  
 * distribute, sublicense, and#or sell copies of the Software, and to   
 * permit persons to whom the Software is furnished to do so, subject to
 * the following conditions:                                            
 *                                                                      
 * The above copyright notice and this permission notice shall be       
 * included in all copies or substantial portions of the Software.      
 *                                                                      
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,      
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF   
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
 * IN NO EVENT SHALL THE AUTHORS BE LIABLE FOR ANY CLAIM, DAMAGES OR    
 * OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
 * ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
 * OTHER DEALINGS IN THE SOFTWARE.                                      
 */
//Marks the right margin of code *******************************************************************
package
{
	
	//--------------------------------------
	//  Imports
	//--------------------------------------
	import com.pblabs.animation.Animator;
	import com.pblabs.animation.AnimatorComponent;
	import com.pblabs.box2D.Box2DDebugComponent;
	import com.pblabs.box2D.Box2DManagerComponent;
	import com.pblabs.box2D.Box2DSpatialComponent;
	import com.pblabs.box2D.PolygonCollisionShape;
	import com.pblabs.engine.PBE;
	import com.pblabs.engine.core.LevelEvent;
	import com.pblabs.engine.core.TemplateEvent;
	import com.pblabs.engine.debug.Logger;
	import com.pblabs.engine.entity.IEntity;
	import com.pblabs.rendering2D.DisplayObjectScene;
	import com.pblabs.rendering2D.SimpleSpatialComponent;
	import com.pblabs.rendering2D.SpriteSheetRenderer;
	import com.pblabs.rendering2D.spritesheet.SWFSpriteSheetComponent;
	import com.pblabs.rendering2D.ui.SceneView;
	import com.rmc.projects.pbebox2dradialgravity.box2d.SuperPolygonCollisionShape;
	import com.rmc.projects.pbebox2dradialgravity.components.RadialGravityComponent;
	import com.rmc.projects.pbebox2dradialgravity.components.ShardsAPIRenderComponent;
	import com.rmc.projects.pbebox2dradialgravity.resources.MyResources;
	
	import flash.display.Sprite;
	import flash.events.MouseEvent;
	import flash.geom.Point;
	import flash.text.TextField;
	import flash.text.TextFieldAutoSize;
	
	//--------------------------------------
	//  Metadata
	//--------------------------------------
	
	
	//--------------------------------------
	//  Class
	//--------------------------------------
	/**
	 * <p>The primary document class for the game.</p>
	 * 
	 * <p>AUTHOR  		: Samuel Asher Rivello</p>
	 * <p>COMPANY 		: Rivello Multimedia Consulting</p>
	 * <p>CREATION DATE 	: Jun 18, 2011</p>
	 * 
	 * @example Here is a code example. 
	 *  
	 * <listing version="3.0">
	 * <p>Describe this code example.</p>
	 *
	 * </listing>
	 *
	 */
	public class PBEBox2DRadialGravity extends Sprite
	{		
		
		//--------------------------------------
		//  Properties
		//--------------------------------------
		//PUBLIC GETTER/SETTERS
		
		//PUBLIC CONST
		
		//PRIVATE
		/**
		 *	Click the mouse to create a new entity. Each has a unique name
		 *  using this variable. 
		 */		
		private var _boxTemplateEntitiesCreatedIndex_uint : uint;
		
		//--------------------------------------
		//  Constructor
		//--------------------------------------
		/**
		 * This is the constructor.
		 * 
		 */
		public function PBEBox2DRadialGravity()
		{
			//SUPER
			super (); 
			
			//PROPERTIES
			_boxTemplateEntitiesCreatedIndex_uint = 0;
			
			//	-------------------------------------------
			//1. START PBE
			PBE.startup(this);
			PBE.mainStage.frameRate = 60;
			
			//	-------------------------------------------
			//3. LOAD EMBEDDED RESOURCS
			PBE.addResources(new MyResources()); 
			
			//	-------------------------------------------
			//4. OTHER SETTINGS
			//	0.5 =  HALF-SPEED, 
			//	2.0 = DOUBLE SPEED (SMOOTHER ANIMATION)
			PBE.processManager.timeScale = 1;
			
			//	-------------------------------------------
			//6. LEVEL MANAGER
			
			//	REGISTER TYPES - REQUIRED!
			PBE.registerType(Box2DManagerComponent);
			PBE.registerType(Box2DSpatialComponent);
			PBE.registerType(Box2DDebugComponent);
			PBE.registerType(DisplayObjectScene);
			PBE.registerType(PolygonCollisionShape);
			PBE.registerType(AnimatorComponent);
			PBE.registerType(Animator);
			
			//	REGISTER TYPES - CUSTOM
			PBE.registerType(RadialGravityComponent);
			PBE.registerType(SuperPolygonCollisionShape);
			PBE.registerType(ShardsAPIRenderComponent);
			
			_loadAllLevels();
			
			//	-------------------------------------------
			//	TEST TRACING OUTPUT MESSAGE
			Logger.print(this, "Press 'Alt/Option' + '~' to Open Debugger");
			
			//CREATE TEXTFIELD FOR INSTRUCTIONS
			var textField : TextField = new TextField ();
			textField.autoSize = TextFieldAutoSize.LEFT;
			textField.multiline = true;
			textField.htmlText = "Demo is Interactive. <BR>The earths affect only the moons with radial gravity (configurable in xml). <BR>Mouse click anywhere to reverse all (both) RadialGravities. <BR>Moons collide only with moons (configurable in xml).";
			addChild(textField);
			
			//EVENTS
			PBE.mainStage.addEventListener(MouseEvent.CLICK, _onStageMouseClick);
			
		}
		//--------------------------------------
		//  Methods
		//--------------------------------------		
		//PUBLIC	
		
		//PRIVATE	
		
		/**
		 * PBE: CREATE SCENE ENTITY
		 * 
		 * @return void
		 */
		private function _createScene ( ) : void 
		{
			//DISPLAY LEVEL
			return;
			var sceneView : SceneView 	= new SceneView();
			sceneView.name 				= "MainSceneView";
			PBE.initializeScene(sceneView, "MainSceneView");
			
			
		}
		/**
		 * PBE: CREATE SCENE ENTITY
		 * 
		 * @return void
		 */
		private function _loadAllLevels ( ) : void 
		{
			//	LOAD LEVEL
			PBE.templateManager.addEventListener(TemplateEvent.GROUP_LOADED, _onTemplateManagerGroupLoaded);
			PBE.levelManager.addEventListener(LevelEvent.READY_EVENT, _onLevelManagerReady);
			PBE.levelManager.addEventListener(LevelEvent.LEVEL_LOADED_EVENT, _onLevelManagerLoaded);
			PBE.levelManager.addEventListener(LevelEvent.LEVEL_UNLOADED_EVENT, _onLevelManagerUnloaded);
			
			//LEVEL 1 - LOAD RootGroup TOO
			PBE.levelManager.addFileReference(1, "./level1.pbelevel");
			PBE.levelManager.addGroupReference(1, "RootGroup");
			PBE.levelManager.addGroupReference(1, "Level1");
			
			//*********************
			//	THIS DEMO DOES NOT CHANGE LEVELS YET, ONLY LEVEL 1 IS USED.
			//*********************
			
			//LEVEL 2 - LOAD RootGroup TOO
			PBE.levelManager.addGroupReference(2, "RootGroup");
			PBE.levelManager.addGroupReference(2, "Level2");
			
			//LEVEL 3 - LOAD RootGroup TOO
			PBE.levelManager.addGroupReference(3, "RootGroup");
			PBE.levelManager.addGroupReference(3, "Level3");
			
			//LOAD LEVEL 0. NOT SURE WHY WE LOAD '0' THEN WHEN ITS DONE WE LOAD 1. I SEE THIS 
			//DONE ON OTHER DEMOS. SO I DID IT TOO.
			PBE.levelManager.start(0);
			
		}
		
		//--------------------------------------
		//  Event Handlers
		//--------------------------------------		
		/**
		 * Handles the aEvent: <code>LevelEvent.READY_EVENT</code>.
		 * 
		 * @param aEvent <code>LevelEvent</code> The incoming aEvent payload.
		 *  
		 * @return void
		 * 
		 */
		private function _onLevelManagerReady(aEvent:LevelEvent):void
		{
			trace ("!!!!_onLevelManagerReady() level: " + aEvent.level);
			PBE.levelManager.loadLevel(1, true);
		}
		
		/**
		 * Handles the aEvent: <code>LevelEvent.LEVEL_LOADED_EVENT</code>.
		 * 
		 * @param aEvent <code>LevelEvent</code> The incoming aEvent payload.
		 *  
		 * @return void
		 * 
		 */
		private function _onLevelManagerLoaded(aEvent:LevelEvent):void
		{
			trace (">>>>>>>>_onLevelManagerLoaded() level: " + aEvent.level);
			if (aEvent.level == 0) {
				PBE.levelManager.loadLevel(1, true);
				
			} else if (aEvent.level == 1) {
				
			}
			
		}
		
		
		/**
		 * Handles the aEvent: <code>LevelEvent.LEVEL_UNLOADED_EVENT</code>.
		 * 
		 * @param aEvent <code>LevelEvent</code> The incoming aEvent payload.
		 *  
		 * @return void
		 * 
		 */
		private function _onLevelManagerUnloaded(aEvent:LevelEvent):void
		{
			trace ("_onLevelManagerUnloaded() level: " + aEvent.level);
			
		}
		
		
		/**
		 * Handles the aEvent: <code>TemplateEvent.GROUP_LOADED</code>.
		 * 
		 * @param aEvent <code>TemplateEvent</code> The incoming aEvent payload.
		 *  
		 * @return void
		 * 
		 */
		private function _onTemplateManagerGroupLoaded(aEvent: TemplateEvent):void
		{
			trace ("_onTemplateManagerGroupLoaded(), name: " + aEvent.name);
			//if (aEvent.name == "RootGroup") {
			//	createHeroFromXML();
			//}
			
		}
		
		
		/**
		 * Handles the aEvent: <code>MouseEvent.CLICK</code>.
		 * 
		 * @param aEvent <code>MouseEvent</code> The incoming aEvent payload.
		 *  
		 * @return void
		 * 
		 */
		private function _onStageMouseClick(event:MouseEvent):void
		{
			//REVERSE THE RADIAL GRAVITY
			
			//EARTH 1
			var radialGravityComponent1 : RadialGravityComponent = PBE.lookupComponentByName("EarthEntity1", "RadialGravityComponent") as RadialGravityComponent;
			radialGravityComponent1.radialGravityMagnitude = -radialGravityComponent1.radialGravityMagnitude;
			
			//EARTH 2
			var radialGravityComponent2 : RadialGravityComponent = PBE.lookupComponentByName("EarthEntity2", "RadialGravityComponent") as RadialGravityComponent;
			radialGravityComponent2.radialGravityMagnitude = -radialGravityComponent2.radialGravityMagnitude;
		}
		
		
	}
}