/*******************************************************************************
 * PushButton Engine
 * Copyright (C) 2009 PushButton Labs, LLC
 * For more information see http://www.pushbuttonengine.com
 * 
 * This file is licensed under the terms of the MIT license, which is included
 * in the License.html file at the root directory of this SDK.
 ******************************************************************************/
package com.rmc.projects.pbebox2dradialgravity.box2d
{
	import Box2D.Collision.Shapes.b2ShapeDef;
	
	import com.pblabs.box2D.Box2DSpatialComponent;
	import com.pblabs.box2D.PolygonCollisionShape;
	
	public class SuperPolygonCollisionShape extends PolygonCollisionShape
	{
		
		/**
		 * Determines if shape detections collision AND reacts to collision (false) or only detects (true)
		 * 
		 */
		public function get isSensor() 						: Boolean 		{ return _isSensor_boolean; }
		public function set isSensor(aValue : Boolean) 		: void 			{ _isSensor_boolean = aValue; }
		private var _isSensor_boolean : Boolean = false;
		
		
		
		override public function createShape(parent:Box2DSpatialComponent):b2ShapeDef
		{
			var shape:b2ShapeDef = super.createShape(parent);
			shape.isSensor = _isSensor_boolean;
			return shape;
		}
		
	}
}