/**
 * Copyright (C) 2005-2011 by Rivello Multimedia Consulting (RMC).                    
 * code [at] RivelloMultimediaConsulting [dot] com                                                  
 *                                                                      
 * Permission is hereby granted, free of charge, to any person obtaining
 * a copy of this software and associated documentation files (the      
 * "Software"), to deal in the Software without restriction, including  
 * without limitation the rights to use, copy, modify, merge, publish,  
 * distribute, sublicense, and#or sell copies of the Software, and to   
 * permit persons to whom the Software is furnished to do so, subject to
 * the following conditions:                                            
 *                                                                      
 * The above copyright notice and this permission notice shall be       
 * included in all copies or substantial portions of the Software.      
 *                                                                      
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,      
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF   
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
 * IN NO EVENT SHALL THE AUTHORS BE LIABLE FOR ANY CLAIM, DAMAGES OR    
 * OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
 * ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
 * OTHER DEALINGS IN THE SOFTWARE.                                      
 */
// Marks the right margin of code *******************************************************************
package com.rmc.projects.pbebox2dradialgravity.components
{
	
	// --------------------------------------
	// Imports
	// --------------------------------------
	import com.pblabs.engine.PBE;
	import com.pblabs.engine.entity.PropertyReference;
	import com.pblabs.rendering2D.MovieClipRenderer;
	
	import flash.display.MovieClip;
	import flash.geom.Point;
	import flash.utils.getDefinitionByName;
	
	
	// --------------------------------------
	// Metadata
	// --------------------------------------
	
	// --------------------------------------
	// Class
	// --------------------------------------
	/**
	 * <p>This is designed to...</p>
	 * 
	 * <p>AUTHOR  		: Samuel Asher Rivello</p>
	 * <p>COMPANY 		: Rivello Multimedia Consulting</p>
	 * <p>CREATION DATE 	: Jun 18, 2011</p>
	 * 
	 * @example Here is a code example. 
	 *  
	 * <listing version="3.0">
	 * <p>Describe this code example.</p>
	 *
	 * </listing>
	 *
	 * @see com.rmc.templates.TemplateClass
	 *
	 */
	public class ShardsAPIRenderComponent extends MovieClipRenderer
	{
		
		// --------------------------------------
		// Properties
		// --------------------------------------
		// PUBLIC GETTER/SETTERS
		/**
		 * Describe this member.
		 * 
		 */
		public function get clipAssetName() 						: String 		{ return _clipAssetName_str; }
		public function set clipAssetName(aValue : String) 		: void 			{ 
			_clipAssetName_str = aValue; 
			
			//now that we have the asset name, look that up in the resource bundle (in a non-PBE way, that's ok)
			try {
				clip = new resourceBundleClass[_clipAssetName_str]();
			} catch (aError: Error) {
				throw new Error ("Probably resourceBundleClassName was not set in XML or parsed in time. Or... : " + aError);
			}
			
		}
		private var _clipAssetName_str : String;
		
		/**
		 * Describe this member.
		 * 
		 */
		public function get resourceBundleClass() 						: Class		{ return _resourceBundleClass; }
		private var _resourceBundleClass : Class;
		
		/**
		 * Describe this member.
		 * 
		 */
		public function get resourceBundleClassName() 						: String		{ return _resourceBundleClassName_str; }
		public function set resourceBundleClassName(aValue : String) 			: void 		{ 
			_resourceBundleClassName_str = aValue; 
			
			//now that the name is set, get the class
			_resourceBundleClass = Class (getDefinitionByName(_resourceBundleClassName_str) );
			
		}
		private var _resourceBundleClassName_str : String;
		
		
		override protected function getClipInstance():MovieClip
		{
			return clip;
		}
		
		/**
		 * Describe this member.
		 * 
		 */
		public function get currentFrame() 						: uint 		{ return _clipFrame as uint; }
		public function set currentFrame(aValue : uint) 		: void 			{ 
			
			if (clip) {
				//SUPERCLASS WANTS TO PLAY 100% OF THE TIME. SO GOTOANDSTOP HERE MANUALLY AND DISABLE PLAYING IN ALL OTHER LOCATIONS
				_clipFrame = aValue; 
				clip.gotoAndStop(_clipFrame);
			} else {
				trace ("NOTE FOUND: clip is " + clip + " probably clipAssetName wasn't set. clipAssetName = " + clipAssetName);
			}
		}
		
		/**
		 * Describe this member.
		 * 
		 */
		public function get isPlaying() 						: Boolean 		{ return _isPlaying_boolean; }
		public function set isPlaying(aValue : Boolean) 		: void 			{ _isPlaying_boolean = aValue; }
		private var _isPlaying_boolean : Boolean;
		
		
		// PUBLIC CONST
		
		// PRIVATE
		/**
		 * Describe this member.
		 * 
		 */
		private var _sample2_str : String;
		
		
		// --------------------------------------
		// Constructor
		// --------------------------------------
		/**
		 * This is the constructor.
		 * 
		 */
		public function ShardsAPIRenderComponent()
		{
			// SUPER
			super();
			
			// EVENTS
			
			// VARIABLES
			
			// PROPERTIES
			frameRate 			= PBE.mainStage.frameRate;
			_isPlaying_boolean	= false;
			
			//	REQUIRED VALUE = TRUE OTHERWISE OBJECT WON'T 'MOVE'.
			loop					= true;
			
			// METHODS
			
			
		}
		
		
		// --------------------------------------
		// Methods
		// --------------------------------------
		// PUBLIC
		/**
		 * Handles the event: Add 
		 * 
		 * @return void
		 */
		protected override function onAdd() : void
		{
			super.onAdd();
			//
			_onSetup();
		}
		
		/**
		 * Handles the event: Reset 
		 * 
		 * @return void
		 */
		protected override function onReset () : void
		{
			super.onReset();
			//
			_onSetup();
		}
		
		
		
		
		//PROTECTED
		/**
		 * Describe this member.
		 * 
		 * @param aSample_str Describe this parameter.
		 * 
		 * @return String Describe this return.
		 * 
		 */
		override public function set clip(value:MovieClip):void
		{
			//	SUPER
			super.clip = value;
			
			//	REGISTER CENTER FOR NICE ROTATION
			if (super.clip) {
				registrationPoint = new Point (x + clip.width/2, y + clip.height/2);
				
				//	STOP IT ON FRAME 1
				currentFrame = 1;
			} else {
				throw new Error ("NOTE FOUND: clip is " + clip + " probably clipAssetName wasn't set. clipAssetName = " + clipAssetName);
			}
			
		}
		
		/**
		 * Describe this member.
		 * 
		 * @param aSample_str Describe this parameter.
		 * 
		 * @return String Describe this return.
		 * 
		 */
		override public function onFrame(elapsed:Number) : void
		{
			super.onFrame(elapsed);
		}
		
		//	PRIVATE
		/**
		 * Called both on onReset and onAdd
		 * 
		 * @return void
		 */
		private function _onSetup () : void
		{
			//SETUP
			positionProperty 	= new PropertyReference ("@Spatial.position");
			scaleProperty 		= new PropertyReference ("@Spatial.scale");
			rotationProperty 	= new PropertyReference ("@Spatial.rotation");
			sizeProperty 		= new PropertyReference("@Spatial.size");
			
		}
		
		// --------------------------------------
		// Event Handlers
		// --------------------------------------
		
	}
}